package com.proyecto.localizandroid;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.telephony.gsm.SmsMessage;
import android.util.Log;

public class SmsIntentReceiver extends BroadcastReceiver {
	@Override
	public void onReceive(Context context, Intent intent) {		
		SmsMessage msg[] = getMessagesFromIntent(intent);
		
		for(int i=0; i < msg.length; i++) {
			String message = msg[i].getDisplayMessageBody();
			if(message != null && message.length() > 0)	{
				Log.i("MessageListener:",  message);
				
				SharedPreferences passwdfile = context.getSharedPreferences(LocalizAndroid.PASSWORD_PREF_KEY, 0);
				String passwd = passwdfile.getString(LocalizAndroid.PASSWORD_PREF_KEY, null);
					
				if (message.trim().toLowerCase().contains(passwd.toLowerCase())) {
					Intent mIntent = new Intent(context, ServicioLocalizacion.class);
					mIntent.putExtra("dest", msg[i].getOriginatingAddress());
					context.startService(mIntent);									
				}
				
			}
		}
	}
	
	private SmsMessage[] getMessagesFromIntent(Intent intent) {
		SmsMessage retMsgs[] = null;
		Bundle bdl = intent.getExtras();
		try {
			Object pdus[] = (Object [])bdl.get("pdus");
			retMsgs = new SmsMessage[pdus.length];
			for(int n=0; n < pdus.length; n++) {
				byte[] byteData = (byte[])pdus[n];
				retMsgs[n] = SmsMessage.createFromPdu(byteData);
			}
		} catch(Exception e) {
			Log.e("GetMessages", "fail", e);
		}
		return retMsgs;
	}

}

